use TSQL;
GO

-- Converso correcta
select CONVERT( int, 4 );

-- Erro
select CONVERT( int, 'a' );




-- Uma tentativa de converso 
select TRY_CONVERT( int, 4 ),
	   TRY_CONVERT( int, 'a' );

-- Uma construo mais complexa
select case when TRY_CONVERT( int, 'a' ) is null 
				then 'oops' 
			else 'ok' 
	   end;


select nome, salario,
	TRY_CONVERT( decimal(9,2), nome, 1 ) as NomeDecimal,
	TRY_CONVERT( decimal(9,2), salario, 1 ) as SalarioDecimal,
	TRY_CONVERT( int, salario, 1 ) as SalarioEnteiro
	--TRY_PARSE( nome, money, 'PT')
	from dbo.Programadores;





-- Parsing correcto
select PARSE( '1.0' as numeric(9, 2))

-- Erro
select PARSE( 'a' as numeric(9, 2))



-- 'Tenta Parsing'
select nome, try_parse( nome as numeric(9, 2))
	from dbo.Programadores;







-- Logical functions
select iif( 1>2, 0, 1 );

select CHOOSE( 3, 'a', 'b', 'c', 'd' ) as MySelection;
select CHOOSE( 2*2-1, 'a', 'b', 'c', 'd' ) as MySelection;

select CONCAT( '1', 2 ) as Result;


-- Concatatenao com NULL
select '1' + 2 + NULL + 'B' as Result;
select CONCAT( '1', 2, NULL, 'B' ) as Result;


-----------------------------------------------------------
-- Date Functions
select EOMONTH( GetDate() );
select EOMONTH( GetDate(), -2 );

-- y,m,d
select DateFromParts(2012,3,7);

-- hh,mi,ss,fraction,scale
select TimeFromParts(10,05,03,0,0);

-- y,m,d,h,mi,ss,fraction
select DateTimeFromParts(2012,3,7,10,05,03,0);